# These handlers are for updates of type str. We use them to react to inputs
# on the command line interface
def cli_reply(bot, update, args):
    """
    For any update of type telegram.Update or str that contains a command, you
    can get the argument list by appending args to the function parameters.
    Here, we reply to the last active chat with the text after the command.
    """
    #if last_chat_id is not 0:
    #    bot.sendMessage(chat_id=last_chat_id, text=' '.join(args))
    pass

def cli_noncommand(bot, update, update_queue):
    """
    You can also get the update queue as an argument in any handler by
    appending it to the argument list. Be careful with this though.
    Here, we put the input string back into the queue, but as a command.
    To learn more about those optional handler parameters, read:
    http://python-telegram-bot.readthedocs.org/en/latest/telegram.dispatcher.html
    """
    #update_queue.put('/%s' % update)
    pass

def unknown_cli_command(bot, update):
    pass
    #logger.warn("Command not found: %s" % update)

# These are text handlers.
def msg_handler(bot, update):
    """ Handle incoming text from telegram """
    chat = update.message.chat_id
    msg = update.message.text
    user = update.message.from_user.username
    # Add handlers here

def msg_handler_async(bot, update):
    """ Handle incoming text from telegram """
    chat = update.message.chat_id
    msg = update.message.text
    user = update.message.from_user.username
    # Add handlers here


#old main
def main():
    # Create the EventHandler and pass it your bot's token.
    updater = Updater(config.token, workers=16)
    global suicide, docs, docs_admin

    # Get the dispatcher to register handlers
    dp = updater.dispatcher

    # This is how we add handlers for Telegram messages
    dp.addTelegramCommandHandler("start", cmd_start)
    dp.addTelegramCommandHandler("help", cmd_help)
    dp.addTelegramCommandHandler("stop", cmd_stop)
    dp.addUnknownTelegramCommandHandler(unknown_command)

    # Message handlers only receive updates that don't contain commands
    dp.addTelegramMessageHandler(message)

    # Regex handlers will receive all updates on which their regex matches
    dp.addTelegramRegexHandler('.*', any_message)

    # String handlers work pretty much the same
    dp.addStringCommandHandler('reply', cli_reply)
    dp.addUnknownStringCommandHandler(unknown_cli_command)
    dp.addStringRegexHandler('[^/].*', cli_noncommand)

    # All TelegramErrors are caught for you and delivered to the error
    # handler(s). Other types of Errors are not caught.
    dp.addErrorHandler(error)

    skip = ("kitsubot.py", "example.py", "config.py")
    # Load modules!  Copy example.py as needed.
    # The module will be initialized by calling init(dp).
    # You should use these as needed in your init:
    #   dp.addTelegramCommandHandler("command",cmd_command)
    #   dp.addTelegramRegexHandler("regex",cmd_regex)
    #
    x = os.listdir()
    for j in x:
        if not j in skip:
            if not j.endswith(".py"): continue
            m = __import__(j.replace(".py",""), globals=[updater,dp,suicide]);
            logger.info("Loading module %s ..." % j)
            m.init(dp)
            try:
                docs.update(m.docs)
            except:
                pass
            try:
                docs_admin.update(m.docs_admin)
            except:
                pass
            
    # Start the Bot and store the update Queue, so we can insert updates
    update_queue = updater.start_polling(poll_interval=0.1, timeout=10)

    while True:
        sleep(1)
        if suicide:
            updater.stop()
            break

    sys.exit(0)
